#!/bin/bash
#
# dialog.sh

# CONFIG START
  CHARS="a-zA-Z0-9+-_=,.(){}[]'?%*^~@$/"
  ADMDIR=$PWD
  LXDIALOG=$PWD/lxdialog/lxdialog
# CONFIG END

eval {line,subl}=0
while read i ; do
    line=$((${line}+1))
    case ${i:0:1} in
	:) subl=$((${subl}+1))
	   mainmenu=$mainmenu":{submenu[${subl}]} \"${i/:} --->\" "
	   ;;
	-) submenu[$subl]=${submenu[$subl]}"${line} \"${i}\" "
	   ;;
	/) IFS=: s=($i)
	   case ${s[3]} in
	      B|L) value[$line]=$(echo ${s[5]} | cut -f $((${s[2]}+1)) -d ',')
		   submenu[$subl]=${submenu[$subl]}"${line} \"< \${value[$line]} > ${s[6]}\" "
		   ;;
	      I|A) value[$line]=${s[2]}
		   submenu[$subl]=${submenu[$subl]}"${line} \"[ \${value[$line]} ] ${s[6]} --->\" "
		  ;;
	   esac
	   ;;
    esac
done < "${ADMDIR}/admin.conf"

unset IFS

dialog_geometry() {
    ROWS="${1:-24}"
    COLS="${2:-78}"
    ROWS="${ROWS/#0/24}"
    COLS="${COLS/#0/78}"
    if [ "${ROWS}" -lt 24 -o "${COLS}" -lt 78 ] ; then
	echo $"Your display is too small to run this script!"
	echo $"It must be at least 24 lines by 78 columns!"
	echo "`stty size` (stty size) ..."
	exit 1
    else
	ROWS="$((ROWS-2))"
	COLS="$((COLS-2))"
	MSIZE="${ROWS} ${COLS} $((ROWS-6))"
    fi
}

  dialog_geometry `stty size 2>/dev/null`
  MAINMENU="${LXDIALOG} --title 'Mainmenu' --menu '' ${MSIZE} \"\${mainchoice}\" ${mainmenu}"
  while : ; do
{ mainchoice=`eval "${MAINMENU}" 2>&1 >&3 3>&-`; } 3>&1
  retval=$?
  case "${retval}" in
     0|3|4|5|6) x=$(eval echo \$${mainchoice/:})
		if [ -z "${x}" ] ; then
		    echo $"submenu currently not available ..."
		    sleep 2
		    continue
		fi
		while : ; do
		SUBMENU="${LXDIALOG} --title 'Submenu' --menu '' ${MSIZE} \"\${subchoice}\" ${x}"
	      { subchoice=`eval "${SUBMENU}" 2>&1 >&3 3>&-`; } 3>&1
		case $? in
		     0|3|4|5|6)
			 while read i ; do
				  case ${i:0:1} in
					-) y=
					   ;;
					/) IFS=: s=($i)
					   unset IFS
					   case ${s[3]} in
						B|L) IFS=: NUM=($(echo ${s[5]// /_} | tr , \\n | grep -n ^${value[$subchoice]}$))
						     unset IFS
						     m=$((${NUM[0]}+1))
						     eval value[$subchoice]=$(echo ${s[5]} | cut -f $m -d ',') 2>/dev/null
						     if [ -z "${value[$subchoice]}" ] ; then
							m=1
							eval value[$subchoice]=$(echo ${s[5]} | cut -f 1 -d ',') 2>/dev/null
						     fi
						     sed -i "${subchoice}s/\(:${s[2]//\//\\/}:\)/:$(($m-1)):/" "${ADMDIR}/admin.conf"
						     y=
						     ;;
						I|A) y=x
						     ;;
					   esac
					  ;;
				esac
				done < <(head -n ${subchoice} "${ADMDIR}/admin.conf" | tail -n 1)
				unset IFS
				if [ "${y}" ] ; then
				    while : ; do
					if { STOUT=$(${LXDIALOG} --clear --title $"Input" --inputbox $"valid sign: ${s[5]}" 8 $((COLS-1)) "${s[2]}" 2>&1 >&3 3>&-); } 3>&1
					then
					    if [ "${s[2]}" != "${STOUT}" ] ; then
						sed -i "${subchoice}s|:${s[2]}:|:${STOUT}:|" "$ADMDIR/admin.conf"
						eval value[$subchoice]="${STOUT// /\\ }" 2>/dev/null
					    fi
					    break
					else
					    break
					fi
				    done
				fi
				;;
			     1) break
				;;
			     2) :
				;;
		esac
		done
		;;
	     1) break
		;;
	     2) :
		;;
  esac
  done
